#include <iostream>
#include <random>
#define rep(i, n) for (int i = 0; i < int(n); i++)
using P = std::pair<int, int>;
template <class F>
inline constexpr decltype(auto) lambda_fix(F&& f) {
	return [f = std::forward<F>(f)](auto&&... args) {
		return f(f, std::forward<decltype(args)>(args)...);
	};
}
constexpr int N = 201, sx = 100, sy = 100, T = 10000, M = 1000, S1 = 5, S2 = 4,
			  S3 = 7;
constexpr int dx[] = {0, 1, 0, -1}, dy[] = {1, 0, -1, 0};
int grid[201][201];
char field[201][201];
bool used[201][201];
int main(int argc, char* argv[]) {
	if (argc > 2) {
		printf("usage: <This Program> <Seed>");
		return 1;
	}
	std::mt19937 mt;
	if (argc == 1) {
		std::random_device rd;
		mt.seed(rd());
	} else
		mt.seed(std::atol(argv[1]));
	while (true) {
		rep(j, N) rep(k, N) grid[j][k] = 0;
		rep(j, 50) {
			int x = mt() % N, y = mt() % N, h = mt() % 71;
			rep(k, N) {
				rep(l, N) {
					grid[k][l] +=
						std::max(0, h - std::abs(k - x) - std::abs(l - y));
				}
			}
		}
		rep(j, N) {
			rep(k, N) {
				if (grid[j][k] < 30)
					field[j][k] = '-';
				else
					field[j][k] = '.';
				used[j][k] = false;
			}
		}
		if (field[sx][sy] == '-') continue;
		lambda_fix([&](auto self, int x, int y) -> void {
			used[x][y] = true;
			rep(j, 4) {
				int nx = x + dx[j], ny = y + dy[j];
				if (0 <= nx && nx < N && 0 <= ny && ny < N && !used[nx][ny] &&
					field[nx][ny] != '-')
					self(self, nx, ny);
			}
		})(100, 100);
		std::vector<P> vec;
		int cnt = 0;
		rep(j, N) {
			rep(k, N) {
				if (field[j][k] != '-' && !used[j][k]) goto end;
				if (field[j][k] != '-') cnt++;
			}
		}
		if (cnt * 2 < N * N) goto end;
		std::cout << N << " " << T << " " << M << " " << sx << " " << sy
				  << std::endl;
		std::cout << S1 << " " << S2 << " " << S3 << std::endl;
		rep(j, N) {
			rep(k, N) std::cout << field[j][k];
			std::cout << std::endl;
		}
		rep(j, N) {
			rep(k, N) {
				if (field[j][k] != '-') vec.emplace_back(j, k);
			}
		}
		rep(j, M) {
			int t = mt() % 3 + 1;
			std::cout << t << " ";
			if (t == 1 || t == 2) {
				int x = mt() % vec.size();
				std::cout << vec[x].first << " " << vec[x].second << std::endl;
			} else {
				int c = mt() % 5 + 1;
				std::cout << c << std::endl;
				rep(k, c) {
					int x = mt() % vec.size();
					std::cout << vec[x].first << " " << vec[x].second
							  << std::endl;
				}
			}
		}
		break;
	end:;
	}
}