#include <cassert>
#include <fstream>
#include <iostream>
#include <vector>
#define rep(i, n) for (int i = 0; i < int(n); i++)
#define REP(i, n) for (int i = 1; i <= int(n); i++)
using P = std::pair<int, int>;
int N, T, M, sx, sy, S1, S2, S3;
int t[1000];

bool mis_ac1[1000], mis_ac2[1000];
std::vector<bool> mis_ac3[1000];

std::vector<int> mis_g1[201][201], mis_g2[201][201];
std::vector<P> mis_g3[201][201];

char grid[201][201];
void WA() {
	std::cerr << "Wrong Answer" << std::endl;
	exit(-1);
}
int main(int argc, char* argv[]) {
	if (argc != 3) {
		printf("usage: <This program> <Input File> <Output File>\n");
		return 1;
	}
	try {
		std::ifstream inf(argv[1]);
		std::ifstream ouf(argv[2]);
		//入力をとる
		inf >> N >> T >> M >> sx >> sy >> S1 >> S2 >> S3;
		rep(i, N) rep(j, N) inf >> grid[i][j];
		rep(i, M) {
			inf >> t[i];
			if (t[i] == 1) {
				int x, y;
				inf >> x >> y;
				mis_g1[x][y].emplace_back(i);
			} else if (t[i] == 2) {
				int x, y;
				inf >> x >> y;
				mis_g2[x][y].emplace_back(i);
			} else {
				int k;
				inf >> k;
				mis_ac3[i].resize(k);
				rep(j, k) {
					int x, y;
					inf >> x >> y;
					mis_g3[x][y].emplace_back(i, j);
				}
			}
		}
		//位置の初期化
		int nx1 = sx, ny1 = sy, nx2 = sx, ny2 = sy;
		//出力を受け取る
		REP(i, T) {
			int x1, y1, x2, y2;
			if (!(ouf >> x1 >> y1 >> x2 >> y2)) WA();
			//移動系チェック
			if (x1 < 0 || N <= x1 || y1 < 0 || N <= y1) WA();
			if (x2 < 0 || N <= x2 || y2 < 0 || N <= y2) WA();
			if (std::abs(nx1 - x1) + std::abs(ny1 - y1) > 1) WA();
			if (std::abs(nx2 - x2) + std::abs(ny2 - y2) > 1) WA();
			if (grid[x1][y1] == '-' || grid[x2][y2] == '-') WA();
			//ミッション 1 の確認
			if (x1 == x2 && y1 == y2) {
				for (int j : mis_g1[x1][y1]) mis_ac1[j] = true;
			}
			//ミッション 2 の確認
			for (int j : mis_g2[x1][y1]) mis_ac2[j] = true;
			for (int j : mis_g2[x2][y2]) mis_ac2[j] = true;
			//ミッション 3 の確認
			for (P j : mis_g3[x1][y1]) mis_ac3[j.first][j.second] = true;
			for (P j : mis_g3[x2][y2]) mis_ac3[j.first][j.second] = true;
			//更新
			nx1 = x1;
			ny1 = y1;
			nx2 = x2;
			ny2 = y2;
		}
		//点数計算
		int score = 0;
		rep(i, M) {
			if (t[i] == 1)
				score += int(mis_ac1[i]) * S1;
			else if (t[i] == 2)
				score += int(mis_ac2[i]) * S2;
			else {
				bool flag = true;
				for (int j : mis_ac3[i]) flag &= j;
				score += int(flag) * S3;
			}
		}
		printf("Accepted: %d points\n", score);
		return 0;
	} catch (char* err) {
		std::cerr << "error: " << err << std::endl;
		return 1;
	}
	return 1;
}
